Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/Problem/CountOdds.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/Problem/CountOdds.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/Problem/CountOdds.cs	(revision 14513)
@@ -1,87 +1,87 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Diagnostics;
-using System.Linq;
-using System.Threading.Tasks;
-using HeuristicLab.Algorithms.PushGP.Expressions;
-using HeuristicLab.Algorithms.PushGP.Interpreter;
-using Microsoft.VisualStudio.TestTools.UnitTesting;
+﻿namespace HeuristicLab.Tests.Benchmark.Problem {
+  using System;
+  using System.Collections.Generic;
+  using System.Diagnostics;
+  using System.Linq;
+  using System.Threading.Tasks;
 
-namespace HeuristicLab.Tests.Benchmark.Problem
-{
-    [TestClass]
-    public class CountOdds : Problem<long[], long>
-    {
-        public const string ProblemFileName = "examples-count-odds.csv";
+  using HeuristicLab.Algorithms.PushGP.Data.Random;
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+  using HeuristicLab.Algorithms.PushGP.Generators;
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-        public CountOdds()
-        {
-            Examples = GetExamples(ProblemFileName, ExampleConverter.Integers, ExampleConverter.Integer);
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  [TestClass]
+  public class CountOdds : Problem<long[], long> {
+    public CountOdds() {
+      this.Examples = this.GetExamples(
+        "examples-count-odds.csv",
+        ExampleConverter.Integers,
+        ExampleConverter.Integer);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void RandomWalk() {
+      var maxProgramSizeLimit = 100;
+      var iterations = 4000;
+      var best = double.MaxValue;
+      var globalExecCounter = 0;
+      var lockObj = new object();
+      var lockCount = new object();
+      RandomFactory.Seed = 1337;
+
+      Expression bestProgram = null;
+      var config = new Configuration { EvalPushLimit = 500 };
+      var pool = new PushGpInterpreterPool(config);
+
+      Parallel.For(0, iterations, i => {
+
+        var execCounter = 0;
+        var program = CodeGenerator.RandomProgram(maxProgramSizeLimit);
+        var results = new List<long>();
+
+        using (var interpreter = pool.GetInstance()) {
+          foreach (var example in this.Examples) {
+            if (example.Input.Length > 0) interpreter.IntegerStack.Push(example.Input);
+
+            interpreter.Interpret(program);
+
+            if (!interpreter.IntegerStack.IsEmpty) {
+              var diff = example.Output - interpreter.IntegerStack.Top;
+              var value = diff == long.MinValue ? 10000 : Math.Min(Math.Abs(diff), 10000);
+
+              results.Add(value);
+            }
+
+            execCounter += interpreter.ExecCounter;
+            interpreter.Clear();
+          }
         }
 
-        [TestMethod]
-        [TestProperty("Time", "Medium")]
-        [TestCategory("ProblemTest")]
-        public void RandomWalk()
-        {
-            var maxProgramSizeLimit = 1000;
-            var iterations = 20000;
-            var best = double.MaxValue;
-            Expression bestProgram = null;
-            var lockObj = new object();
-            var globalExecCounter = 0;
+        lock (lockCount) {
+          globalExecCounter += execCounter;
+        }
 
+        if (results.Count == 0) return;
 
-            Parallel.For(0, iterations, async i =>
-            {
-                var interpreter = new PushGPInterpreter(new Configuration
-                {
-                    EvalPushLimit = 10000
-                });
+        var avg = results.Average();
 
-                var execCounter = 0;
-                var program = interpreter.CodeGenerator.RandomProgram(maxProgramSizeLimit);
-                var results = new List<long>();
+        if (avg >= best) return;
 
-                foreach (var example in Examples)
-                {
-                    if (example.Input.Length > 0)
-                    {
-                        interpreter.IntegerStack.Push(example.Input);
-                    }
+        lock (lockObj) {
+          if (avg < best) {
+            best = avg;
+            bestProgram = program;
+          }
+        }
+      });
 
-                    await interpreter.InterpretAsync(program);
-
-                    if (!interpreter.IntegerStack.IsEmpty)
-                    {
-                        var value = Math.Abs(example.Output - interpreter.IntegerStack.Top);
-
-                        results.Add(Math.Min(value, 1000));
-                    }
-
-                    execCounter += interpreter.ExecCounter;
-                    interpreter.Clear();
-                }
-
-                if (!results.Any())
-                    return;
-
-                var avg = results.Average();
-
-                lock (lockObj)
-                {
-                    if (avg < best)
-                    {
-                        best = avg;
-                        bestProgram = program;
-                        globalExecCounter += execCounter;
-                    }
-                }
-            });
-
-            Debug.WriteLine("Best: {0}", best);
-            Debug.WriteLine("Program: {0}", bestProgram);
-            Debug.WriteLine("ExecCounter: {0}", globalExecCounter);
-        }
+      Debug.WriteLine("Best: {0}", best);
+      Debug.WriteLine("Program: {0}", bestProgram);
+      Debug.WriteLine("ExecCounter: {0}", globalExecCounter);
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/Problem/Problem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/Problem/Problem.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/Problem/Problem.cs	(revision 14513)
@@ -1,70 +1,67 @@
-﻿using System;
-using System.Collections.Generic;
-using System.IO;
-using System.IO.Compression;
-using System.Linq;
-using System.Reflection;
-using System.Text.RegularExpressions;
+﻿namespace HeuristicLab.Tests.Benchmark.Problem
+{
+  using System;
+  using System.Collections.Generic;
+  using System.IO;
+  using System.IO.Compression;
+  using System.Linq;
+  using System.Reflection;
+  using System.Text.RegularExpressions;
 
-namespace HeuristicLab.Tests.Benchmark.Problem
-{
-    public class Problem<Tin, Tout>
+  public class Problem<Tin, Tout>
+  {
+    public const char ExampleSeparator = ',';
+
+    public const string ArchiveFileName = "BenchmarkExamples.zip";
+
+    private static readonly string instanceArchiveName = GetResourceName(ArchiveFileName);
+
+    protected List<Example<Tin, Tout>> Examples { get; set; }
+
+    protected List<Example<Tin, Tout>> GetExamples(
+      string problemName,
+      Converter<string, Tin> inputConverter,
+      Converter<string, Tout> outputConverter)
     {
-        public const char ExampleSeparator = ',';
-        public const string ArchiveFileName = "BenchmarkExamples.zip";
+      using (var file = this.GetType().Assembly.GetManifestResourceStream(instanceArchiveName))
+      {
+        using (var archive = new ZipArchive(file, ZipArchiveMode.Read))
+        {
+          var entry = archive.Entries.SingleOrDefault(x => x.Name == problemName);
 
-        private static string instanceArchiveName = GetResourceName(ArchiveFileName);
+          using (var reader = new StreamReader(entry.Open()))
+          {
+            var examples = new List<Example<Tin, Tout>>();
 
-        protected List<Example<Tin, Tout>> Examples { get; set; }
+            // skip training headline
+            if (reader.Peek() >= 0) reader.ReadLine();
 
-        protected List<Example<Tin, Tout>> GetExamples(string problemName, Converter<string, Tin> inputConverter, Converter<string, Tout> outputConverter)
-        {
-            using (var file = GetType().Assembly.GetManifestResourceStream(instanceArchiveName))
-            using (var archive = new ZipArchive(file, ZipArchiveMode.Read))
+            while (reader.Peek() >= 0)
             {
-                var entry = archive.Entries.SingleOrDefault(x => x.Name == problemName);
+              var line = reader.ReadLine();
 
-                using (var reader = new StreamReader(entry.Open()))
-                {
-                    var examples = new List<Example<Tin, Tout>>();
+              // return
+              if (line.StartsWith("test")) break;
 
-                    // skip training headline
-                    if (reader.Peek() >= 0)
-                    {
-                        reader.ReadLine();
-                    }
+              var values = line.Split(ExampleSeparator);
 
-                    while (reader.Peek() >= 0)
-                    {
-                        var line = reader.ReadLine();
+              examples.Add(
+                new Example<Tin, Tout> { Input = inputConverter(values[0]), Output = outputConverter(values[1]) });
+            }
 
-                        // return
-                        if (line.StartsWith("test"))
-                        {
-                            break;
-                        }
+            return examples;
+          }
+        }
+      }
+    }
 
-                        var values = line.Split(ExampleSeparator);
-
-                        examples.Add(new Example<Tin, Tout>
-                        {
-                            Input = inputConverter(values[0]),
-                            Output = outputConverter(values[1])
-                        });
-                    }
-
-                    return examples;
-                }
-            }
-        }
-
-        private static string GetResourceName(string fileName)
-        {
-            return Assembly
-                .GetExecutingAssembly()
-                .GetManifestResourceNames()
-                .Where(x => Regex.Match(x, @".*\.Data\." + fileName).Success)
-                .SingleOrDefault();
-        }
+    private static string GetResourceName(string fileName)
+    {
+      return
+        Assembly.GetExecutingAssembly()
+          .GetManifestResourceNames()
+          .Where(x => Regex.Match(x, @".*\.Data\." + fileName).Success)
+          .SingleOrDefault();
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 14513)
@@ -27,4 +27,5 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <LangVersion>5</LangVersion>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
@@ -74,5 +75,6 @@
     <Compile Include="Interpreter\Expressions\CodeExpressionTests.cs" />
     <Compile Include="Interpreter\Expressions\IntegerExpressionTests.cs" />
-    <Compile Include="Interpreter\InterpreterTest.cs" />
+    <Compile Include="Interpreter\Expressions\StandardTests.cs" />
+    <Compile Include="Interpreter\ExpressionTest.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
@@ -86,5 +88,7 @@
     <EmbeddedResource Include="Benchmark\Data\BenchmarkExamples.zip" />
   </ItemGroup>
-  <ItemGroup />
+  <ItemGroup>
+    <Folder Include="Interpreter\Generator\" />
+  </ItemGroup>
   <Choose>
     <When Condition="'$(VisualStudioVersion)' == '10.0' And '$(IsCodedUITest)' == 'True'">
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj.user
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj.user	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj.user	(revision 14513)
@@ -2,5 +2,5 @@
 <Project ToolsVersion="14.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
   <PropertyGroup>
-    <ProjectView>ProjectFiles</ProjectView>
+    <ProjectView>ShowAllFiles</ProjectView>
   </PropertyGroup>
 </Project>
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs	(revision 14513)
@@ -0,0 +1,38 @@
+﻿namespace HeuristicLab.Tests.Interpreter
+{
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  public class ExpressionTest
+  {
+    protected PushGpInterpreter interpreter;
+
+    [TestInitialize]
+    public void BeforeTest()
+    {
+      this.interpreter = new PushGpInterpreter(new Configuration { TopLevelPushCode = false });
+    }
+
+    protected void TestStackCounts(
+      int? execStack = 0,
+      int? codeStack = 0,
+      int? nameStack = 0,
+      int? booleanStack = 0,
+      int? floatStack = 0,
+      int? integerStack = 0)
+    {
+      if (execStack.HasValue) Assert.AreEqual(execStack, this.interpreter.ExecStack.Count);
+
+      if (codeStack.HasValue) Assert.AreEqual(codeStack, this.interpreter.CodeStack.Count);
+
+      if (nameStack.HasValue) Assert.AreEqual(nameStack, this.interpreter.NameStack.Count);
+
+      if (booleanStack.HasValue) Assert.AreEqual(booleanStack, this.interpreter.BooleanStack.Count);
+
+      if (floatStack.HasValue) Assert.AreEqual(floatStack, this.interpreter.FloatStack.Count);
+
+      if (integerStack.HasValue) Assert.AreEqual(integerStack, this.interpreter.IntegerStack.Count);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/BooleanExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/BooleanExpressionTests.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/BooleanExpressionTests.cs	(revision 14513)
@@ -1,145 +1,156 @@
-﻿using HeuristicLab.Algorithms.PushGP.Expressions;
-using HeuristicLab.Algorithms.PushGP.Stack;
-using Microsoft.VisualStudio.TestTools.UnitTesting;
+﻿namespace HeuristicLab.Tests.Interpreter.Expressions
+{
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+  using HeuristicLab.Algorithms.PushGP.Stack;
 
-namespace HeuristicLab.Tests.Interpreter.Expressions
-{
-    [TestClass]
-    public class BooleanExpressionTests : CommonTests<bool>
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  [TestClass]
+  public class BooleanExpressionTests : CommonTests<bool>
+  {
+    protected override string TypeName
     {
-        protected override string TypeName { get { return "BOOLEAN"; } }
-        protected override IStack<bool> Stack { get { return interpreter.BooleanStack; } }
+      get
+      {
+        return "BOOLEAN";
+      }
+    }
 
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("BooleanExpressionTest")]
-        public void TestAnd()
-        {
-            interpreter.BooleanStack.Push(true, false);
-            interpreter.Interpret(new BooleanAndExpression());
+    protected override IStack<bool> Stack
+    {
+      get
+      {
+        return this.interpreter.BooleanStack;
+      }
+    }
 
-            Assert.AreEqual(false, interpreter.BooleanStack.Top);
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("BooleanExpressionTest")]
+    public void TestAnd()
+    {
+      this.interpreter.BooleanStack.Push(true, false);
+      this.interpreter.Interpret(new BooleanAndExpression());
 
-            TestStackCounts(booleanStack: 1);
-        }
+      Assert.AreEqual(false, this.interpreter.BooleanStack.Top);
 
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("BooleanExpressionTest")]
-        public void TestAndWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("AND", 1);
-        }
+      this.TestStackCounts(booleanStack: 1);
+    }
 
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("BooleanExpressionTest")]
-        public void TestOr()
-        {
-            interpreter.BooleanStack.Push(true, false);
-            interpreter.Interpret(new BooleanOrExpression());
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("BooleanExpressionTest")]
+    public void TestAndWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("AND", 1);
+    }
 
-            Assert.AreEqual(true, interpreter.BooleanStack.Top);
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("BooleanExpressionTest")]
+    public void TestOr()
+    {
+      this.interpreter.BooleanStack.Push(true, false);
+      this.interpreter.Interpret(new BooleanOrExpression());
 
-            TestStackCounts(booleanStack: 1);
-        }
+      Assert.AreEqual(true, this.interpreter.BooleanStack.Top);
 
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("BooleanExpressionTest")]
-        public void TestOrWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("OR", 1);
-        }
+      this.TestStackCounts(booleanStack: 1);
+    }
 
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("BooleanExpressionTest")]
-        public void TestNot()
-        {
-            interpreter.BooleanStack.Push(true);
-            interpreter.Interpret(new BooleanNotExpression());
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("BooleanExpressionTest")]
+    public void TestOrWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("OR", 1);
+    }
 
-            Assert.AreEqual(false, interpreter.BooleanStack.Top);
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("BooleanExpressionTest")]
+    public void TestNot()
+    {
+      this.interpreter.BooleanStack.Push(true);
+      this.interpreter.Interpret(new BooleanNotExpression());
 
-            TestStackCounts(booleanStack: 1);
-        }
+      Assert.AreEqual(false, this.interpreter.BooleanStack.Top);
 
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("BooleanExpressionTest")]
-        public void TestNotWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("NOT");
-        }
+      this.TestStackCounts(booleanStack: 1);
+    }
 
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("BooleanExpressionTest")]
-        public void TestFromFloat()
-        {
-            interpreter.FloatStack.Push(2.0);
-            interpreter.Interpret(new BooleanFromFloatExpression());
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("BooleanExpressionTest")]
+    public void TestNotWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("NOT");
+    }
 
-            Assert.AreEqual(true, interpreter.BooleanStack.Top);
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("BooleanExpressionTest")]
+    public void TestFromFloat()
+    {
+      this.interpreter.FloatStack.Push(2.0);
+      this.interpreter.Interpret(new BooleanFromFloatExpression());
 
-            TestStackCounts(booleanStack: 1);
-        }
+      Assert.AreEqual(true, this.interpreter.BooleanStack.Top);
 
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("BooleanExpressionTest")]
-        public void TestFromFloatWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("FROMFLOAT");
-        }
+      this.TestStackCounts(booleanStack: 1);
+    }
 
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("BooleanExpressionTest")]
-        public void TestFromInteger()
-        {
-            interpreter.IntegerStack.Push(2);
-            interpreter.Interpret(new BooleanFromIntegerExpression());
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("BooleanExpressionTest")]
+    public void TestFromFloatWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("FROMFLOAT");
+    }
 
-            Assert.AreEqual(true, interpreter.BooleanStack.Top);
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("BooleanExpressionTest")]
+    public void TestFromInteger()
+    {
+      this.interpreter.IntegerStack.Push(2);
+      this.interpreter.Interpret(new BooleanFromIntegerExpression());
 
-            TestStackCounts(booleanStack: 1);
-        }
+      Assert.AreEqual(true, this.interpreter.BooleanStack.Top);
 
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("BooleanExpressionTest")]
-        public void TestFromIntegerWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("FROMINTEGER");
-        }
+      this.TestStackCounts(booleanStack: 1);
+    }
 
-        protected override bool[] GetValues(int count)
-        {
-            var values = new bool[count];
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("BooleanExpressionTest")]
+    public void TestFromIntegerWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("FROMINTEGER");
+    }
 
-            for (var i = 0; i < count; i++)
-            {
-                values[i] = i % 2 == 0;
-            }
+    protected override bool[] GetValues(int count)
+    {
+      var values = new bool[count];
 
-            return values;
-        }
+      for (var i = 0; i < count; i++) values[i] = i % 2 == 0;
 
-        protected override void CheckOtherStacksAreEmpty()
-        {
-            TestStackCounts(booleanStack: null);
-        }
+      return values;
     }
+
+    protected override void CheckOtherStacksAreEmpty()
+    {
+      this.TestStackCounts(booleanStack: null);
+    }
+  }
 }
